package ch.kri.fhbb.RMI;

import java.rmi.*;
import ch.kri.fhbb.RMI.RmiTextObject.*;

public class RmiClient extends javax.swing.JFrame {
    // Wird mit dem Remote-Objekt belegt
    static RemoteTextObject txtObject;
    
    /** Creates new form RmiClient */
    public RmiClient() {
        initComponents();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jLabel1 = new javax.swing.JLabel();
        txtData = new javax.swing.JTextField();
        btnGetData = new javax.swing.JButton();
        btnSetData = new javax.swing.JButton();
        
        getContentPane().setLayout(new java.awt.GridLayout(2, 2));
        
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });
        
        jLabel1.setText("Client Data");
        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        getContentPane().add(jLabel1);
        
        getContentPane().add(txtData);
        
        btnGetData.setText("Get Data");
        btnGetData.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnGetDataActionPerformed(evt);
            }
        });
        
        getContentPane().add(btnGetData);
        
        btnSetData.setText("Set Data");
        btnSetData.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSetDataActionPerformed(evt);
            }
        });
        
        getContentPane().add(btnSetData);
        
        pack();
    }//GEN-END:initComponents

    private void btnSetDataActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSetDataActionPerformed
        try {
            txtObject.setText( txtData.getText() );
        }
        catch (Exception e) {
            System.err.println(e);
        }
    }//GEN-LAST:event_btnSetDataActionPerformed

    private void btnGetDataActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnGetDataActionPerformed
        try {
            txtData.setText( txtObject.getText() );
        }
        catch (Exception e) {
            System.err.println(e);
        }        
    }//GEN-LAST:event_btnGetDataActionPerformed

    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        System.exit(0);
    }//GEN-LAST:event_exitForm

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        try {
            String url = "rmi://127.0.0.1/textServer";
        
            // list all registered methods
            String[] names = Naming.list("rmi://127.0.0.1/");
            for (int i = 0; i < names.length; i++) {
                System.out.print(names[i] +  ", ");
            }
            System.out.println("");
            
            // connect to the rmi server
            txtObject = (RemoteTextObject) Naming.lookup(url);

            // GUI anzeigen
            new RmiClient().show();
        }
        catch (Exception e) {
            System.err.println(e);
        }
    }


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JTextField txtData;
    private javax.swing.JButton btnGetData;
    private javax.swing.JButton btnSetData;
    // End of variables declaration//GEN-END:variables

}
